GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Data::PrimitiveTypeArray2D< T > Class Template Reference

DataHandler for 2D arrays of primitive types. More...

`#include <primitiveTypeArray2D.h>`

Inheritance diagram for Data::PrimitiveTypeArray2D< T >:

## Public Member Functions
| PrimitiveTypeArray2D (const size_t w=2, const size_t h=4)
| Constructor for the 2D array.
| PrimitiveTypeArray2D (const PrimitiveTypeArray2D< T > &other)
| Copy constructor.
| PrimitiveTypeArray2D (const Array2DWrapper< T > &other)
| Copy content from an Array2DWrapper.
virtual DataHandler * | clone () const override
| Inherited from DataHandler.
void | resetData () override
| Sets all elements of the Array to 0 (or its equivalent for the given template param.)
void | setDataAt (const std::type_info &type, const size_t address, const T &value)
| Set the data at the given address to the given value.
PrimitiveTypeArray2D< T > & | operator= (const PrimitiveTypeArray2D< T > &other)
| Assignement Operator for PrimitiveTypeArray2D<T>
Public Member Functions inherited from Data::Array2DWrapper< T >
| Array2DWrapper (const size_t w=2, const size_t h=4, std::vector< T > *ptr=nullptr)
| Constructor for the 2D array.
| Array2DWrapper (const Array2DWrapper &other)=default
| Default copy constructor.
virtual | ~Array2DWrapper ()=default
| Default destructor.
virtual size_t | getAddressSpace (const std::type_info &type) const override
| Inherited from DataHandler.
virtual std::vector< size_t > | getAddressesAccessed (const std::type_info &type, const size_t address) const override
| Inherited from DataHandler.
virtual UntypedSharedPtr | getDataAt (const std::type_info &type, const size_t address) const override
| Inherited from DataHandler.
virtual std::vector< size_t > | getDimensionsSize () const override
| Inherited from DataHandler.
Public Member Functions inherited from Data::ArrayWrapper< T >
| ArrayWrapper (size_t size=8, std::vector< T > *ptr=nullptr)
| Constructor for the ArrayWrapper class.
virtual | ~ArrayWrapper ()=default
| Default destructor.
| ArrayWrapper (const ArrayWrapper< T > &other)=default
| Default copy constructor.
| ArrayWrapper (const DataHandler &other, size_t size)
| Copy constructor for DataHandler.
virtual bool | canHandle (const std::type_info &type) const override
| Inherited from DataHandler.
virtual size_t | getLargestAddressSpace (void) const override
| Inherited from DataHandler.
void | invalidateCachedHash ()
| Invalidate the hash of the container.
void | setPointer (std::vector< T > *ptr)
| Set the pointer of the ArrayWrapper.
virtual const std::type_info & | getNativeType () const override
| Inherited from DataHandler.
Public Member Functions inherited from Data::DataHandler
| DataHandler ()
| Default constructor of the DataHandler class.
virtual | ~DataHandler ()=default
| Default destructor.
| DataHandler (const DataHandler &other)=default
| Default copy constructor.
size_t | getId () const
| Get the ID of the DataHandler.
virtual size_t | getHash () const
| Get the current value of the hash for this DataHandler.
uint64_t | scaleLocation (const uint64_t rawLocation, const std::type_info &type) const
| Scale a location from the Environment largestAddressSpace to the largestAddressSpace of the dataHandler, for the given data type.

## Protected Attributes
std::vector< T > | data
| Array storing the data of the PrimitiveTypeArray2D.
Protected Attributes inherited from Data::Array2DWrapper< T >
size_t | width
| Number of columns of the 2D array.
size_t | height
| Number of lines of the 2D array.
Protected Attributes inherited from Data::ArrayWrapper< T >
const size_t | nbElements
| Number of elements contained pointer vector.
std::vector< T > * | containerPtr
| Pointer to the array containing the data accessed through the ArrayWrapper.
Protected Attributes inherited from Data::DataHandler
const size_t | id
| Identifier of each DataHandler.
size_t | cachedHash
| Cached value returned by the getHash() function.
bool | invalidCachedHash
| Boolean value indicating whether the current cachedValue is valid, or not.

## Additional Inherited Members
Protected Member Functions inherited from Data::Array2DWrapper< T >
size_t | getAddressSpace (const std::type_info &type, size_t *dim1, size_t *dim2) const
| Utility function for the class.
Protected Member Functions inherited from Data::ArrayWrapper< T >
void | checkAddressAndType (const std::type_info &type, const size_t &address) const
virtual size_t | updateHash () const override
| Implementation of the updateHash method.
Static Protected Attributes inherited from Data::DataHandler
static size_t | count = 0
| Static count used to initialize the id of each DataHandler.

## Detailed Description

template<typename T>
class Data::PrimitiveTypeArray2D< T >

DataHandler for 2D arrays of primitive types.

This specialization of the Array2DWrapper template class provides the possibility to get data with the type:

- T: The primitive type.
- T[n][m]: with $n <= height$ and $m <= width$ of the PrimitiveTypeArray2D.
- T[n]: with $n <= width$ of the PrimitiveTypeArray2D.

It is important to note that only spatially coherent values will be returned when arrays are requested. For example, when requesting a 1D array of N pixels, the returned pixels will always be taken from a single line of pixels, and will never comprise the last pixel from a line i, and the first pixels from line i+1. This means that the addressable space for arrays will be less than a 1D PrimitiveDataArray with the same number of nbElements.

## Constructor & Destructor Documentation

## ◆ PrimitiveTypeArray2D()

template<typename T >

Data::PrimitiveTypeArray2D< T >::PrimitiveTypeArray2D | ( | const size_t | w = 2,
|  | const size_t | h = 4 )
| inline

Constructor for the 2D array.

The size of the underlying PrimitiveTypeArray will be $nbElements = h*w$.

Parameters

  [in] | w | The width of the 2D array.
  [in] | h | The height of the 2D array.

## Member Function Documentation

## ◆ clone()

template<typename T >

DataHandler * Data::PrimitiveTypeArray2D< T >::clone | ( |  | ) | const
| inline override virtual

Inherited from DataHandler.

Reimplemented from Data::Array2DWrapper< T >.

## ◆ operator=()

template<class T >

PrimitiveTypeArray2D< T > & Data::PrimitiveTypeArray2D< T >::operator= | ( | const PrimitiveTypeArray2D< T > & | other | ) |

Assignement Operator for PrimitiveTypeArray2D<T>

Copy nbElements and data from the right side argument to the left side argument

Parameters

  [in] | other | the left side argument, to be assigned to the right side argument.

Returns
  the assigned PrimitiveTypeArray2D

Exceptions

  std::domain_error | if both arguents do not have the same size, which implies that assignement cannot be successfull.

## ◆ resetData()

template<class T >

void Data::PrimitiveTypeArray2D< T >::resetData | ( |  | ) |
| override virtual

Sets all elements of the Array to 0 (or its equivalent for the given template param.)

Reimplemented from Data::ArrayWrapper< T >.

## ◆ setDataAt()

template<class T >

void Data::PrimitiveTypeArray2D< T >::setDataAt | ( | const std::type_info & | type,
|  | const size_t | address,
|  | const T & | value )

Set the data at the given address to the given value.

This method is not (yet) part of the DataHandler class as for now, the TPG engine does not need to update data of DataHandler, except for the one used as registers, which are managed with a PrimitiveTypeArray<double>.

Invalidates the cache.

Parameters

  [in] | type | the std::type_info of data set.
  [in] | address | the location of the data to set.
  [in] | value | a const reference to the PrimitiveType holding a value of the data to write in the current PrimitiveTypeArray

Exceptions

  std::invalid_argument | if the given data type is not handled by the DataHandler.
  std::out_of_range | if the given address is invalid for the given data type.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/data/array2DWrapper.h
- D:/a/gegelati/gegelati/gegelatilib/include/data/primitiveTypeArray2D.h